/* TestAddRemoveHost.java
 *
 * -----------------------------------------------------------------
 * Licensed Materials - Property of IBM
 * 5724Q99
 * (C) Copyright IBM Corp. 1998, 2007
 * All Rights Reserved
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 * -----------------------------------------------------------------
 * $Id: //depot/rbo/src/packages/ibmee/javaapi/examples/TestAddRemoveHost.java#5 $
 */

package examples;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.InetAddress;

import com.ibm.rbapi.RBHost;
import com.ibm.rbapi.RBHostRecs;
import com.ibm.rbapi.RBServer;

public class TestAddRemoveHost {

    public static void main(String[] args) {

        if (args.length < 3) {
            System.out.println("usage: TestAddRemoveHost <ip> <port> <password>");
            return;
        }
        
        try {
            System.out.println("TestAddRemoveHost starting.");
            InetAddress ip = InetAddress.getByName(args[0]);
            int port = Integer.parseInt(args[1]);
            String token = args[2];
            
            RBServer rbServer = new RBServer(ip, port, token); 
            // Abort if the server is not ready after 15 seconds
            rbServer.isReady(15000);

            BufferedReader inReader = new BufferedReader(new InputStreamReader(System.in));
            while (true) {
                RBHostRecs rbHostRecs = rbServer.getHosts("", "");
                RBHost[] rbHosts = rbHostRecs.subList(0, rbHostRecs.size());
                for (int i=0; i< rbHosts.length; i++) {
                    RBHost current = rbHosts[i];
                    System.out.println(i + ") " + current.getIPAddress() 
                            + " / " + current.getMacAddress());
                }
                System.out.print("\n1=add 2=remove 3=quit 4=resetstartpage other=refresh? ");
                try {
                    int choice = Integer.parseInt(inReader.readLine().trim());
                    if (choice == 3) { // quit
                        break;
                    }
                    if (choice == 1) { // add
                        System.out.print("\nIP address to register? ");
                        String addr = inReader.readLine().trim();
                        System.out.println("\nCalling registerHost with "+addr);
                        rbServer.registerHost(addr, "", "", "");
                        continue;
                    }
                    if (choice == 2) {  // remove
                        System.out.print("\nHost to remove? ");
                        int pos = Integer.parseInt(inReader.readLine().trim());
                        System.out.println("\nCalling remove with "+pos);
                        rbHosts[pos].remove();
                        continue;
                    }
                    if (choice == 4) { // reset startpage

                        int count = rbServer.resetAllStartPages();
                        System.out.println("Start pages reset:" + count);

                        /* the rest of this test is not working because registerHost always uses TPMFOSD startpage

                    RBServerConfig sc = rbServer.getConfig();
                    String original = sc.getDefaultStartPage();
                    sc.setDefaultStartPage("TestAddRemoveHost.java");
                    rbServer.updateConfig(sc);
                    System.out.println("Server default start page has been changed");

                    RBHost newhost = rbServer.registerHost("192.168.192.168", "", "", "");
                    System.out.println("A new host has been registered with IP"+newhost.getIPAddress());

                    System.out.print("Press enter to continue");
                    inReader.readLine();

                    count = rbServer.resetAllStartPages();
                    System.out.println("Start pages reset:" + count +" expected: 1");

                    sc.setDefaultStartPage(original);
                    rbServer.updateConfig(sc);
                    System.out.println("Server default start page has been restored ("+original+")");

                    newhost.remove();
                    System.out.println("The new host has been removed");

                         */

                    }
                } catch (NumberFormatException nfe) {
                    // Do nothing, let's just loop again and refresh
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
